/***************************************
**  matrix.h                          **
****************************************
**  CPSC281             Assignment 2  **
**  February 13, 2000     Question 1  **
**  Ben Damm               230002428  **
**  Derek Lewis            230009120  **
***************************************/
#ifndef X_MATRIX_H
#define X_MATRIX_H

#include <iostream>
#include <string>

#include "matrixException.h"

template<class T>
class Matrix
{
  public:
    Matrix();
    Matrix(int _rows, int _cols);
    Matrix(const Matrix& matrix);
    virtual ~Matrix();

    virtual Matrix& operator=(const Matrix& matrix);
    virtual void swap(Matrix& matrix);

    virtual T get(int row, int col) const;
    virtual void set(int row, int col, T val);

    virtual int getRows() const;
    virtual int getCols() const;
  
    virtual Matrix add(T val) const;

    virtual void rowSwap(int row1, int row2);
    virtual void rowMultiply(int row, T val);
    virtual void rowAdd(int row1, int row2, T val);

    virtual bool equals(const Matrix& matrix) const;
    virtual bool isZero() const;
    virtual bool isIdentity() const;
    
    virtual Matrix add(const Matrix& matrix) const;
    virtual Matrix subtract(const Matrix& matrix) const;
    virtual Matrix multiply(const Matrix& matrix) const;
    
    virtual Matrix transpose() const;
    
    virtual ostream& print(ostream& out) const;
    virtual string toString() const;
  
//  protected:
  
    virtual void resize(int _rows, int _cols);
  
    int rows;
    int cols;
    T* data;
  
};

template<class T>
ostream& operator<<(ostream& out, Matrix<T>& matrix);

#include "matrix.cpp"

#endif
